#pragma once

#include "SampleGrabberCB.h"

class AudioGrabberObserver;

//=====================================================================================//
//                                 class AudioGrabber                                  //
//=====================================================================================//
class AudioGrabber : public SampleGrabberCB
{
public:

	AudioGrabberObserver& m_observer;

public:
	AudioGrabber(AudioGrabberObserver& observer);
	~AudioGrabber();
public:
	///	receives a pointer to the sample buffer
	STDMETHOD(BufferCB)(double SampleTime,BYTE *pBuffer,long BufferLen);
	/// receives a pointer to the media sample
	STDMETHOD(SampleCB)(double SampleTime,IMediaSample *pSample);

};

//=====================================================================================//
//                             class AudioGrabberObserver                              //
//=====================================================================================//
class AudioGrabberObserver
{
public:
	virtual ~AudioGrabberObserver() {}
	///	process audio data callback
	virtual void onAudioData(const char* data,unsigned int size,unsigned int timestamp) = 0;

};
